'use strict';

const { GraphOperation } = require('../GraphOperation');
const { GraphDeleteAction } = require('./GraphDeleteAction');

class GraphDelete extends GraphOperation {
  createActions() {
    return [
      new GraphDeleteAction({
        nodes: this.currentGraph.nodes.filter(currentNode =>
          this.graphOptions.shouldDeleteOrUnrelate(currentNode, this.graph)
        ),

        graph: this.graph,
        graphOptions: this.graphOptions
      })
    ];
  }
}

module.exports = {
  GraphDelete
};
